## sagemath 9.0

=== sage/Makefile ===
--- 
+++ 
@@ -53,9 +53,11 @@
 		fi; )
 
 # This is used to monitor progress towards Python 3 and prevent
-# regressions.
-buildbot-python3: configure
-	./configure --with-python=3
+# regressions. Should be removed after the full switch to python3.
+#
+# As of Sage 9.0: keep the build target for backward compatibility,
+# but it just runs "make".
+buildbot-python3:
 	$(MAKE)
 
 # Preemptively download all standard upstream source tarballs.
@@ -76,16 +78,18 @@
 	./sage -i pyopenssl
 
 misc-clean:
-	@echo "Deleting miscellaneous artifacts generated by build system ..."
+	@echo "Deleting build artifacts generated by autoconf, automake, make ..."
 	rm -rf logs
 	rm -rf dist
 	rm -rf tmp
-	rm -f aclocal.m4 config.log config.status confcache
+	rm -f aclocal.m4 config.log confcache
 	rm -rf autom4te.cache
 	rm -f build/make/Makefile build/make/Makefile-auto
 
 bdist-clean: clean
 	$(MAKE) misc-clean
+	@echo "Deleting build artifacts generated by configure ..."
+	rm -f config.status
 
 distclean: build-clean
 	$(MAKE) misc-clean
@@ -104,7 +108,7 @@
 
 # Remove everything that is not necessary to run Sage and pass all its
 # doctests.
-micro_release: bdist-clean sagelib-clean
+micro_release: sagelib-clean misc-clean
 	@echo "Stripping binaries ..."
 	LC_ALL=C find local/lib local/bin -type f -exec strip '{}' ';' 2>&1 | grep -v "File format not recognized" |  grep -v "File truncated" || true
 	@echo "Removing sphinx artifacts..."
@@ -120,7 +124,7 @@
 	@# We need local/, the dependencies and the built Sage library itself.
 	@# We keep VERSION.txt.
 	@# We keep COPYING.txt so we ship a license with this distribution.
-	find . -name . -o -prune ! -name src ! -name sage ! -name local ! -name VERSION.txt ! -name COPYING.txt ! -name build -exec rm -rf \{\} \;
+	find . -name . -o -prune ! -name config.status ! -name src ! -name sage ! -name local ! -name VERSION.txt ! -name COPYING.txt ! -name build -exec rm -rf \{\} \;
 	cd src && find . -name . -o -prune ! -name sage ! -name bin ! -name doc -exec rm -rf \{\} \;
 	if command -v rdfind > /dev/null; then \
 		echo "Hardlinking identical files."; \
@@ -131,7 +135,7 @@
 
 # Leaves everything that is needed to make the next "make" fast but removes
 # all the cheap build artifacts that can be quickly regenerated.
-fast-rebuild-clean: misc-clean bdist-clean
+fast-rebuild-clean: misc-clean
 	rm -rf upstream/
 	rm -rf src/build/temp.*
 	# Without site-packages/sage sage does not start but copying/compiling
@@ -143,7 +147,6 @@
 
 TESTALL = ./sage -t --all
 PTESTALL = ./sage -t -p --all
-PTEST_PYTHON3 = cat src/ext/doctest/python3-known-passing.txt | xargs ./sage -t --long -p
 
 # Flags for ./sage -t --all.
 # By default, include all tests marked 'dochtml' -- see
@@ -188,9 +191,6 @@
 
 ptestoptionallong: all
 	$(PTESTALL) --long --logfile=logs/ptestoptionallong.log
-
-ptest-python3: buildbot-python3
-	$(PTEST_PYTHON3) --logfile=logs/ptest_python3.log
 
 configure: configure.ac src/bin/sage-version.sh m4/*.m4 build/pkgs/*/spkg-configure.m4
 	./bootstrap -d
@@ -212,4 +212,4 @@
 	misc-clean bdist-clean distclean bootstrap-clean maintainer-clean \
 	test check testoptional testall testlong testoptionallong testallong \
 	ptest ptestoptional ptestall ptestlong ptestoptionallong ptestallong \
-	buildbot-python3 ptest-python3 list
+	buildbot-python3 list
