=== debian/changelog ===
sagemath (9.0-1ubuntu4) focal; urgency=medium

  * Allow up to 350 test failures.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 14:46:38 +0100

sagemath (9.0-1ubuntu3) focal; urgency=medium

  * Don't try to build on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 07:23:00 +0100

sagemath (9.0-1ubuntu2) focal; urgency=medium

  * No-change upload for libm4rie soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 01 Feb 2020 06:12:23 +0100

sagemath (9.0-1ubuntu1) focal; urgency=medium

  [ Tobias Hansen ]
  * New patches:
    - u0-version-python-3.8.patch                #27754

  [ Matthias Klose ]
  * Allow up to 300 test failures instead of 65.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 29 Jan 2020 17:51:55 +0100

sagemath (9.0-1) unstable; urgency=medium

  [ Tobias Hansen ]
  * New upstream release.
  * New (Build-)Depends:
    - ipython3 (>= 7.11.1) (Closes: #949287)
  * Remove (Build-)Depends:
    - python3-prompt-toolkit (Closes: #944544)
  * New patches (from Arch Linux):
    - u0-version-ipython-7.patch (Closes: #949446)
  * Remove patches:
    - u0-32bit-overflow-trac-28795.patch         #28795
    - u0-version-threejs-111.patch               #28560
    - d1-packages-exclude-pip.patch
    - d1-python3-shebang.patch
    - df-python_security.patch
    - dt-version-sympy-1.3.patch
  * Modify d1-sage-env.patch:
    Source sage-env earlier to fix 'sage -v' (Closes: #948731)
  * Depend on cython3 instead of cython (Closes: #938426)
  * Allow 25 failed indep doctests.

  [ Julien Puydt ]
  * Update d1-sage-env.patch to find scripts (Closes: #948212)

 -- Tobias Hansen <thansen@debian.org>  Wed, 22 Jan 2020 22:37:42 +0100

sagemath (8.9-3) unstable; urgency=medium

  * New (Build-)Depends:
    - libjs-three (>= 111)
  * New patch (Closes: #944648)
    - u0-32bit-overflow-trac-28795.patch         #28795
    - u0-version-threejs-111.patch               #28560
    - d1-packages-exclude-pip

 -- Tobias Hansen <thansen@debian.org>  Sun, 01 Dec 2019 12:26:58 +0000

sagemath (8.9-2) unstable; urgency=medium

  * Follow best practices for blas in Debian:
    - Build-Depend on libblas-dev instead of libopenblas-dev|libatlas-base-dev
    - Recommend libopenblas-base|libblis2|libatlas3-base|libblas3|libblas.so.3
  * Update pplpy documentation path for pplpy 0.8.4-3.
  * Add python3 environment variables to d/rules export-build-env.
  * New (Build-)Depends:
    - brial (>= 1.2.5-2)
  * Override lintian error for sagemath-dbgsym: field-too-long 'Build-Ids'.

 -- Tobias Hansen <thansen@debian.org>  Sun, 10 Nov 2019 21:41:38 +0100

sagemath (8.9-1) unstable; urgency=medium

  * New upstream release.
  * New (Build-)Depends:
    - libgivaro-dev (>= 4.1.1-2)

 -- Tobias Hansen <thansen@debian.org>  Tue, 01 Oct 2019 11:29:02 +0200

sagemath (8.9~beta9-1) unstable; urgency=medium

  [ Martin von Gagern ]
  * New patches:
    - dt-version-ipywidgets-6-tests.patch

  [ Tobias Hansen ]
  * New upstream release.
  * Use Python 3. (Closes: #938426, #939402)
  * Drop the deprecated Sage Notebook (sagenb) which is not
    Python 3 compatible. It is replaced by the Jupyter notebook.
  * New (Build-)Depends:
    - libpynac-dev (>= 0.7.26-2) (linked against libpython3)
    - libgivaro-dev (>= 4.1.1)
    - fflas-ffpack (>= 2.4.3)
    - liblinbox-dev (>= 1.6.3)
  * New patches:
    - u2-version-rpy-3.patch
    - d1-python3-shebang.patch
    - dt-version-sympy-1.3.patch
  * Remove obsolete patches:
    - debian/patches/d0-arb.patch
    - dt-work-around-doc-common-conf.patch
  * Replace language specific documentation packages
    by a single package sagemath-doc containing all languages.
  * Simplify pruner script, decleare all standard packages
    as installed.
  * Fix 3 doctests in interfaces/maxima_abstract.py.

 -- Tobias Hansen <thansen@debian.org>  Wed, 11 Sep 2019 21:12:30 +0200

sagemath (8.8-1) unstable; urgency=medium

  * New upstream release. (Closes: #932367, #934171)
  * New (Build-)Depends:
    - libbrial-dev (>= 1.2.5)
    - libbrial-groebner-dev (>= 1.2.5)
    - libec-dev (>= 20190226)
    - maxima-sage (>= 5.42.2)
    - python-cypari2 (>= 2.1)
    - python-gmpy2
    - python-nose
    - python-ppl
    - python-ppl-doc
    - python-scipy (>= 1.2)
    - python-sphinx (>= 1.8.5)
    - sagemath-database-conway-polynomials (>= 0.5-7)
  * Remove patches (applied upstream):
    - u0-version-numpy-1.16-inline-fortran.patch #27061
    - u0-version-sphinx-1.8.patch                #26451
    - u0-version-sphinx-1.8-dependency.patch     #26949
    - u1-sphinx-1.8-doctest-transform.patch      #27528
    - u2-libgap-symbol-loading.patch             #26930
    - d1-disable-post-install-tests.patch
  * Patches with non-trivial modifications:
    - u0-version-sphinx-1.8.patch                #26451
    - d0-singular.patch
    - d0-paths.patch
    - d0-libgap-path.patch
    - d1-install-paths.patch
    - d1-sage-cli.patch
    - d1-sage-env.patch
    - dt-version-ipywidgets-6-revert-23177.patch
  * Allow up to 65 failed tests.

 -- Tobias Hansen <thansen@debian.org>  Sun, 01 Sep 2019 16:14:42 +0000
