=== debian/watch ===
version=4
http://files.sagemath.org/src/index.html ./sage-([\d\.]+)\.tar\.gz
