## sagemath 9.2~beta12

=== debian/changelog ===
sagemath (9.2~beta12-1) unstable; urgency=medium

  * New upstream release. (Closes: #949023, #963338)
  * We are now using upstream's new configure script that checks for
    system packages and configures sage to use them. It does not
    recognize all system packages yet, so we patched it to never
    build any spkg's (d1-no-spkg-builds.patch).
    At the same time we changed some details about how sage is installed
    and tried to remove as many patches as possible.
  * Add debian/depcheck.py and run it after configure.
    This script checks for all (Build-)Depends of the Debian package
    if they appear in the debian.txt files under sage/build/pkgs/*/distros
    and reports which ones do not appear in debian.txt files.
    This can be used to find obsolete package Depends and to help create
    missing debian.txt files.
  * New (Build-)Depends:
    - curl
    - ecl (>= 20.4.24)
    - glpk-utils
    - libcurl4-openssl-dev
    - libopenblas-dev
    - libzmq3-dev
    - maxima-sage (>= 5.44.0)
    - pari-gp2c
    - pari-elldata
    - pari-galpol
    - ppl-dev
    - pynac (>= 0.7.26-5)
    - python3-sphinx (>= 3.0)
    - python3-tk
    - yasm
  * Remove (Build-)Depends:
    - libblas-dev
    - python3-brial (>= 1.2.5-2)
  * New patches:
    - u0-version-flint-2.6.3.patch               #29719
    - d0-arb.patch
    - d1-sage.patch
    - d1-no-spkg-builds.patch
    - d1-system-python-packages.patch
    - dt-avoid-ecl-timeout.patch
    - dt-avoid-giac-segfault.patch
  * Remove patches (in refactoring for 9.2):
    - u1-fix-atrocious-symlink-logic.patch       #22444
    - u1-looser-doctest-basename.patch           #22445
    - u1-workaround-sympow-malloc-perturb.patch
    - u2-allow-override-sage-local.patch
    - d0-arb.patch
    - d0-disable-jsmol.patch
    - d1-sage-cli.patch
    - df-sage-gap-reset-doctest.patch
    - df-silence_ecl_opt_signals.patch
    - d0-threejs-default-in-notebooks.patch
    - d0-paths.patch
    - d0-threejs-offline-paths.patch
    - d1-install-paths.patch
    - d1-multiarch-python-paths.patch
    - dt-version-glpk-4.60-extra-hacky-fixes.patch
    - dt-more-fix-test-cases.patch
    - dt-work-around-singular-mips64el-segfault.patch
  * Remove patches (applied upstream in 9.2):
    - u0-version-sphinx-2.4.patch                #28856
    - u0-version-pari-2.11.3.patch               #29313
    - u0-version-ecl-16.1.3.patch                #22191
    - u0-version-ipython-7.patch                 #28197
    - u2-version-matplotlib-3.2.1.patch
    - u0-version-python-3.8.patch                #27754
  * Remove patches (applied upstream in 9.1):
    - u0-version-scipy-1.4.patch                 #29115
    - u0-version-sympy-1.5.patch                 #28911
    - u1-pkgconfig-extra-link-flags.patch        #27205
    - u1-fix-trivial-test-cases.patch
    - u2-version-rpy-3.patch
    - d0-nauty.patch
    - d1-fakeroot.patch
    - dt-version-glpk-4.65-ignore-warnings.patch
  * Pass --enable-build-as-root to ./configure.

 -- Tobias Hansen <thansen@debian.org>  Sat, 12 Sep 2020 09:52:45 +0000

sagemath (9.0-4) unstable; urgency=medium

  * New (Build-)Depends:
    - gap-dev (>= 4.11.0)
    - libgap-dev
  * New patches:
    - u0-version-gap-4.11.patch                  #29314
    - u0-version-sphinx-2.4.patch                #28856
    - u0-version-scipy-1.4.patch                 #29115
  * Remove patches:
    - d0-libgap-path.patch
    - df-revert-minor-feature-dependent-on-python-patch.patch
    - df-subprocess-sphinx.patch
  * Modified patches:
    - u0-version-python-3.8.patch (add 32-bit hashes)
  * Allow up to 200 failed doctests.
  * Stop using dh_sphinxdoc.

 -- Tobias Hansen <thansen@debian.org>  Sat, 25 Apr 2020 15:09:00 +0000

sagemath (9.0-3) unstable; urgency=medium

  [ Julien Puydt ]
  * Mark the -doc-en package M-A: foreign following hinter.

  [ Tobias Hansen ]
  * New (Build-)Depends:
    - pari (>= 2.11.4~pre1)
    - gap-atlasrep (>= 2.1.0-2)
    - libec-dev (>= 20190909-3)
  * Remove (Build-)Depends:
    - python3-openid   #29320
    - python3-twisted  #29320
  * New patches:
    - u0-version-python-3.8.patch (Closes: #950147)
    - u0-version-pari-2.11.3.patch               #29313
    - u0-version-sympy-1.5.patch                 #28911
    - u2-version-matplotlib-3.2.1.patch (Closes: #954504)

 -- Tobias Hansen <thansen@debian.org>  Sat, 04 Apr 2020 20:48:51 +0200

sagemath (9.0-2) unstable; urgency=medium

  * Update PPLPY_DOCS variable following move of pplpy documentation.
    (Closes: #952618)

 -- Tobias Hansen <thansen@debian.org>  Wed, 26 Feb 2020 16:32:50 +0000
